////////////////////////////////////////////////////////////////////////
// ssmd0.c
// Affichage d'une image NON compress avec le fichier .pal
// associ
// 
// Avec diffrent type d'affichage de l'image
//
// Affichage Haut -> Bas Ok
// Affichage Bas -> Haut Ok
// Affichage Drtoite -> Gauche Ok
//Affichage Gauche -> Droite OK
// Affichage par carre OK
//
// Affichage par roulo Ok (A voir quand mme les valeurs du tableau Roulo !!!)
//
////////////////////////////////////////////////////////////////////////

#define  SCR_SET_MODE0_s \
	__asm	ld a,#0 \
	call #0xBC0E \
	__endasm;

#define  SCR_SET_MODE1_s \
	__asm	ld a,#1 \
	call #0xBC0E \
	__endasm;

#define  SCR_SET_MODE2_s \
	__asm	ld a,#2 \
	call #0xBC0E \
	__endasm;
	
#define KM_WAIT_CHAR_s \
	__asm \
	call #0xBB06 \
	__endasm


const char* const FileP[10] = {"00.pal","03.pal","04.pal","08.pal","11.pal","16.pal","18.pal","19.pal","192.pal",'\0'};
const char* const FileS[10] = {"00.scr","03.scr","04.scr","08.scr","11.scr","16.scr","18.scr","19.scr","192.scr",'\0'};

// pour la palette
const unsigned char CpcVGA[ 28 ] = {84,68,85,92,88,93,76,69,77,86,70,87,94,64,95,78,71,79,82,66,83,90,89,91,74,67,75,0};


// pour l'affichage en roulo
unsigned char Roulo[23]={62,58,54,50,46,43,40,37,35,33,32,31,30,29,27,25,22,19,16,12,8,4,0};


// pour l'affichage en bloc
typedef struct _bloc
{
  unsigned int x;
  unsigned char y;
}t_bloc;

static t_bloc Bufmatrice[20][25]; // buffer de la matrice pour l'effect carr
static t_bloc BufmatriceTMP; // buffer de la matrice pour l'effect carr



// IL FAUT UTILISER "--oldralloc" POUR COMPILER !
// code retout :
// 0 Ok
// -1 Erreur
int ReadFileBin(char* filename, char* readbuffer)
{

__asm

	; Initialisation de l amsdos (ROM 7) avant le changement d un fichier
	ld   	hl,(#0xBE7D)	; adresse de la zone rserve AMSDOS
	ld   	a,(hl)			; drive
	push 	hl
	push 	af
	ld      de,#0x40		;DE-HL contient la plage dans laquelle la rom doit tre recherche
	ld      hl,#0xABFF
	ld      c,#7			;contient l adresse de slection de rom  tester
	call    #0xBCCE			;initialisation d une rom de second plan
	pop		af
	pop		hl
	ld		(hl),a			; on remet le drive courant
	
	; rcupere le parametre char* filename
	LD L, 4(IX)
	LD H, 5(IX)
	;LD B, 8(IX)
	
	; calcule la longeur du nom de fichier
	call getfilenamesize
	
	; B = longueur du nom de fichier en caractres
	; HL = l adresse de dbut du nom de fichier
	
	;; DE = l adresse d un tampon 2k
	;; En mode disque: cette mmoire tampon n est pas utilis lorsque Fonction firmware 
	;; CAS EN DIRECT est utilis, il est donc prudent de le mettre nulle (0)
	;; Vous le souhaitez.
	ld de,#0

	;; fonction du firmware pour ouvrir un fichier en lecture
	call #0xbc77

	;; cas_in_open retour:
	;; si le fichier a t ouvert avec succs:
	;; - carry est vrais
	;; - HL contient l adresse de l en-tte du fichier s AMSDOS
	;; - DE contient l adresse de chargement du fichier ( partir de l en-tte)
	;; - BC contient la longueur du fichier ( partir de l en-tete du fichier)
	;; - A contient le type de fichier (2 pour les fichiers binaires)
	; si une erreur on sort le la fonction
    JR NC,ERRDRIV
    JR Z,ERRDRIV
	
	;; fonction du firmware pour charger le fichier en entier
	;; cela fonctionne avec les fichiers qui ont un en-tte AMSDOS (les
	;; fichiers ASCII n ont pas un en-tte)
	
	; rcupere le parametres char* readbuffer
	LD L, 6(IX)
	LD H, 7(IX)

	;; Lecture du fichier
	call #0xbc83

	;; fonction du firmware pour fermer un fichier ouvert en lecture
	call #0xbc7a
	
	jp asmFin

ERRDRIV:
	;LD (FLGERR),A  ;Sort ici si erreur drive
	CALL #0xBC7D
	; il y a une erreur, on retourne cette erreur....
	; enfin pour le moment juste la valeur -1
	ld	hl,#0xFFFF
	pop	ix
	ret
	
	
getfilenamesize:
	push de
	push hl
	ld e,#0
getfilenamesizeloop:
	ld a, (hl)
	or a
	jp z, getfilenamesizeend
	inc hl
	inc e
	jp getfilenamesizeloop
getfilenamesizeend:
	pop hl
	ld b, e
	pop de
	ret	
	
asmFin: 
 	
 __endasm;

 return 0;
}

void SetColor_s(unsigned char NoEncre, unsigned char color)
{
	//A contient le numero de l'encre ; B est la premiere couleur, C la seconde, masi la =  la premire
	__asm
		ld  a, 4(IX)
		ld  b, 5(IX)
		ld  c, 5(IX)
		call #0xBC32
	__endasm;
}

void WaitVbl()
{
__asm
        ld b,#0xF5          ; On selectionne le Port B du PPI
_Synchro: in a,(c)          ; On pique son contenu
        rra               ; On teste si le Bit0=1
        jp nc,_Synchro    ; Si Bit0=0 alors on attend la fin
                          ; du balayage
__endasm;
}

char nGetChar;
char GetChar()
{
  __asm
    LD HL, #_nGetChar
    LD (HL), #0
    CALL #0xBB09 ;KM READ CHAR
    JP NC, _end_getchar
    LD (HL), A
    _end_getchar:
  __endasm;
  
  return nGetChar;
}

// applique un fichier .PAL
void ApplyPal()
{
	char* BufPal;
	unsigned char i;
	unsigned char j;

	BufPal = (char*)((unsigned int)0x2000);

	// met le bon mode
	if ( BufPal[0] == 0 )
		SCR_SET_MODE0_s;
	if ( BufPal[0] == 1 )
		SCR_SET_MODE1_s;
	if ( BufPal[0] == 2 )
		SCR_SET_MODE2_s;
	
	// met les couleurs
	BufPal = (char*)((unsigned int)0x2000+3);
	for ( i = 0; i < 16; i++ )
	{
		for ( j = 0; j < 27; j++ )
		{
			if ( BufPal[ i*12 ] == CpcVGA[ j ] )
			{
				SetColor_s( i, j );
			}
		}
	}

}

unsigned char char1,char2;
unsigned int GetTime_s()
{
	unsigned int nTime = 0;

	__asm
	CALL #0xBD0D ;KL TIME PLEASE
	PUSH HL
	POP DE
	LD HL, #_char1
	LD (HL), D
	LD HL, #_char2
	LD (HL), E
	__endasm;

	nTime = (char1 << 8) + char2;

	return nTime;
}

// fonction de copie mmoire optimis pour le CPC
// bien plus rapide que la fonction de la bibli stendard
void m_memcpy(void* dest, void* src, int lenght)
{
	__asm
	
		push 	HL
		push 	DE
		push 	BC
		
		LD E, 4(IX)   ; (6) HL = adresse de dpart
		LD D, 5(IX)   ; (6) 
		
		LD L, 6(IX)   ; (6) DE = adresse de destination
		LD H, 7(IX)   ; (6) 

		LD C, 8(IX)   ; (6) BC = nombre doctets
		LD B, 9(IX)   ; (6) 
		
        LDIR        ; (5) Recopie de bloc
		
		pop BC
		pop DE
		pop HL
		
	__endasm;
}


// gestion pour les nombres alatoire
// En fait c'est pas vreaiment des nombres alatoire, c'est plus une suite ...
// c'est bien compliqu  expliquer ici....
// j'ai donc fait un truc simple pour le CPC
// je part du GetTime et utilise aussi la valeur du registre R du Z80....

unsigned char rStart;
// initalisation pour les nombre alatoire
void m_randomize()
{
	// on appel la fonction GetTime_s mais on s'en fout de sont retour,
	// ce qui m'intresse c'est la variable global char2 que cette fonction utilise...
	GetTime_s();
	
	rStart = char2;
}

char regR;
void getR()
{
__asm
	LD HL, #_regR
	LD A, R
	LD (HL), A
__endasm;	
}

// rcupre un nobre "alatoire" compris entre 0 et valmax
// il ne faut pas mettre 255 ou 0 pour valmax
unsigned char m_random(unsigned char valmax)
{
	unsigned char rRet = 255;
	
	while (rRet > valmax)
	{
		// on appel la fonction GetTime_s mais on s'en fout de sont retour,
		// ce qui m'intresse c'est la variable global char2 que cette fonction utilise...
		getR();
		GetTime_s();
		
		rRet = (unsigned char)((int)((rStart * char2) / regR ) % valmax);
	}	
	
	return rRet;
}



//
// fonstions pour les diffrents effet d'affichage d'une image
//
int CalYAdr( unsigned char y )
{
	return ( y >> 3 ) * 80 + ( y & 7 ) * 0x800;
}

void AffHautBas(char* BufScr, char* BufDep)
{
	unsigned char y;
	unsigned char x;  // attention, c'est pas les pixels mais les octets qui sont utilis ici !!!
	int iAdr; // adresse de l'cran (relatif  BufScr)

	// affichage de l'image en partant du haut de l'image vers le bas
	for (y = 0; y<200; y++)
	{
		// calcule de l'adresse de debut de la ligne
		iAdr = CalYAdr( y );
		
		for (x = 0; x<80; x++)
		{
			BufScr[iAdr+x] = BufDep[iAdr+x];
		}
	}
}

void AffBasHaut(char* BufScr, char* BufDep)
{
	int y;
	unsigned char x;  // attention, c'est pas les pixels mais les octets qui sont utilis ici !!!
	int iAdr; // adresse de l'cran (relatif  BufScr)

	// affichage de l'image en partant du bas de l'image vers le haut
	for (y = 199; y>=0; y--)
	{
		// calcule de l'adresse de debut de la ligne
		iAdr = CalYAdr( y );
		
		for (x = 0; x<80; x++)
		{
			BufScr[iAdr+x] = BufDep[iAdr+x];
		}
	}
}

void AffDroiteGauche(char* BufScr, char* BufDep)
{
	unsigned char y;
	unsigned char x;  // attention, c'est pas les pixels mais les octets qui sont utilis ici !!!
	int iAdr; // adresse de l'cran (relatif  BufScr)

	// affichage de l'image en partant de la droite vers la gauche
	for (x = 0; x<80; x++)
	{
		for (y = 0; y<200; y++)
		{
			// calcule de l'adresse de debut de la ligne
			iAdr = CalYAdr( y );
			BufScr[iAdr+x] = BufDep[iAdr+x];
		}
	}
}

void AffGaucheDroite(char* BufScr, char* BufDep)
{
	unsigned char y;
	char x;  // attention, c'est pas les pixels mais les octets qui sont utilis ici !!!
	int iAdr; // adresse de l'cran (relatif  BufScr)

	// affichage de l'image en partant de la gauche vers la droite
	for (x = 79; x>=0; x--)
	{
		for (y = 0; y<200; y++)
		{
			// calcule de l'adresse de debut de la ligne
			iAdr = CalYAdr( y );
			BufScr[iAdr+x] = BufDep[iAdr+x];
		}
	}
}

void AffCare(char* BufScr, char* BufDep)
{
	unsigned char y;
	unsigned char x;  // attention, c'est pas les pixels mais les octets qui sont utilis ici !!!
	int iAdr; // adresse de l'cran (relatif  BufScr)

	// pour effect carre
	unsigned char my;
	unsigned char mx;  // attention, c'est pas les pixels mais les octets qui sont utilis ici !!!
	char ir,jr;
	
	// affichage de l'image par carr (alatoire):
	// les blocs font 16*8, il y a donc 20 blocs (4 octets par bloc) en X et 25 bloc en Y
	// on vas faire une matrice de bloc en mmoire

	//Initialise la matrice
	for(my=0;my<25;my++)
	{
		for(mx=0;mx<20;mx++)
		{
			Bufmatrice[mx][my].x = mx<<4;
			Bufmatrice[mx][my].y = my<<3;
		}	
	}
	
	//Melange la matrice
	m_randomize();
	for(my=0;my<25;my++)
	{
		for(mx=0;mx<20;mx++)
		{
			ir=m_random(19);    //Bloc aleatoire
			jr=m_random(24);
			
			//Echange avec un autre bloc
			BufmatriceTMP.x = Bufmatrice[mx][my].x;
			Bufmatrice[mx][my].x = Bufmatrice[ir][jr].x;
			Bufmatrice[ir][jr].x = BufmatriceTMP.x;

			BufmatriceTMP.y = Bufmatrice[mx][my].y;
			Bufmatrice[mx][my].y = Bufmatrice[ir][jr].y;
			Bufmatrice[ir][jr].y = BufmatriceTMP.y;
		}	
	}

	//Affiche la matrice
	for(my=0;my<25;my++)
	{
		for(mx=0;mx<20;mx++)
		{
			for(y=0;y<8;y++)
			{
				// calcule de l'adresse de debut de la ligne
				iAdr = CalYAdr( (Bufmatrice[mx][my].y+y) );
				m_memcpy( BufScr+iAdr+(Bufmatrice[mx][my].x/4), BufDep+iAdr+(Bufmatrice[mx][my].x/4), 4 );
			}
		}
	}
}

void AffRoulo(char* BufScr, char* BufDep)
{
	unsigned char y;
	char x;  // attention, c'est pas les pixels mais les octets qui sont utilis ici !!!
	unsigned int iAdr; // adresse de l'cran (relatif  BufScr)

	// pour l'effec roulo
	unsigned char yr,i;
	unsigned int iAdrd; // adresse destination
	unsigned char hroulo;  // hauteur du roulo
	
	unsigned char Roulo_t[23];

	// affichage en roulo
	hroulo = 23;
	for(i=0;i<hroulo;i++) Roulo_t[i] = Roulo[i] + hroulo; //Ajoute l'epaisseur
	for(y=0;y<200;y++)
	{
		for(i=0;i<hroulo;i++)
		{
			yr=y+Roulo_t[i];
			if(yr<200)
			{
				// calcule de l'adresse de debut de la ligne
				iAdr = ( yr >> 3 ) * 80 + ( yr & 7 ) * 0x800;
				iAdrd = ( y+i >> 3 ) * 80 + ( y+i & 7 ) * 0x800;
				
				// copie la ligne
				m_memcpy( BufScr+iAdrd, BufDep+iAdr, 80 );
			}
		}
		
		// calcule de l'adresse de debut de la ligne
		iAdr = CalYAdr( y );
		// copie la ligne
		m_memcpy( BufScr+iAdr, BufDep+iAdr, 80 );
	}
}

void main()
{
	char* BufDep; // buffer de dpart
	char* BufScr; // buffer de l'cran
	unsigned char curFile;
	unsigned char RendEffet;
	char pressChar;

	BufDep = (char*)((unsigned int)0x4000);
	BufScr = (char*)((unsigned int)0xC000);
	
	// initalisation pour les nombres alatoite
	m_randomize();

	curFile = 0;
	
	// on charge les 1er fichiers images
	// chargement du fichier .pal
	ReadFileBin( (char*)FileP[curFile], 0x2000);
	// chargement de l'images non compresse. On la charge en 0x4000
	ReadFileBin( (char*)FileS[curFile], 0x4000);

	curFile++;
	
	while ( 1 )
	{
		// on applique la palette
		ApplyPal();

		// on fait l'effet d'afichage de faon alatoire...
		RendEffet = m_random(7);
		
		switch( RendEffet )
		{
			case 0:
			case 1: AffHautBas(BufScr, BufDep);
				break;
			case 2: AffBasHaut(BufScr, BufDep);
				break;
			case 3: AffDroiteGauche(BufScr, BufDep);
				break;
			case 4: AffGaucheDroite(BufScr, BufDep);
				break;
			case 5: AffCare(BufScr, BufDep);
				break;
			case 6: AffRoulo(BufScr, BufDep);
				break;
		}

		// si le fichier  lire est vide, on quite la boucle...
		if ( FileP[curFile] == 0 ) 
		{
			// on attent quand mme une touche...
			KM_WAIT_CHAR_s;
			break;
		}


		// on charge le fichier suivent ...
		// chargement du fichier .pal
		ReadFileBin( (char*)FileP[curFile], 0x2000);
		// chargement de l'images non compresse. On la charge en 0x4000
		ReadFileBin( (char*)FileS[curFile], 0x4000);
		
		curFile++;

		// une touche de press ....
		pressChar = GetChar();
		while ( pressChar == 0 )
			pressChar = GetChar();
		
		// esc, on quite
		if ( pressChar == -4 )
			break;
			
		pressChar = 255;	
	}

}
